package code.kalter.longflight;

import java.util.Calendar;
import java.util.Date;
import java.util.Timer;
import java.util.TimerTask;

/**
 * Класс, определяющий текущее время (используется для вывода даты на экране)
 *
 * @author KalterFive
 */
public class Time extends TimerTask {

    private static Time instance;

    public static Time getInstance(int step) {
        if (instance == null) {
            instance = new Time(step);
        }
        return instance;
    }

    private final Timer updating;
    private String time;

    // step - шаг обновления даты
    private Time(int step) {
        time = "Long Flight";
        updating = new Timer();
        updating.schedule(this, 0, step);
    }

    // override
    public void run() {
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(new Date(System.currentTimeMillis()));
        int minute = calendar.get(Calendar.MINUTE);
        int hour = calendar.get(Calendar.HOUR);
        int ampm = calendar.get(Calendar.AM_PM);
        int day = calendar.get(Calendar.DAY_OF_MONTH);
        int month = calendar.get(Calendar.MONTH) + 1;
        int year = calendar.get(Calendar.YEAR) + 1000;
        time = hour + ":" + minute + " " + (ampm == 1 ? "AM" : "PM") + " "
                + day + "." + month + "." + year;
    }

    // override
    public String toString() {
        return time;
    }
}
