package code.kalter.longflight.game.ship;

import code.kalter.longflight.Loader;
import java.io.IOException;
import javax.microedition.lcdui.Image;
import javax.microedition.lcdui.game.Sprite;

/**
 * Свойства всех корабликов врага
 *
 * @author KalterFive
 */
public class ShipEnemy implements Ship {

    private static ShipEnemy instance;

    public static ShipEnemy getInstance() throws IOException {
        if (instance == null) {
            instance = new ShipEnemy();
        }
        return instance;
    }

    private final int[] deltaFire;
    private final int[] life;
    private final int[] speed;
    private final Image[] image;

    private ShipEnemy() throws IOException {
        deltaFire = new int[4];
        life = new int[4];
        speed = new int[4];
        image = new Image[4];

        Loader imageLoader = Loader.getInstance();

        //TYPE: LAX
        deltaFire[LAX] = 2000;
        life[LAX] = 3;
        speed[LAX] = 2;
        image[LAX] = imageLoader.getImage("/gfx/ship/" + LAX + ".png");
        image[LAX] = Image.createImage(image[LAX], 0, 0, 40, 40,
                Sprite.TRANS_MIRROR_ROT180);

        //TYPE: POWERFUL
        deltaFire[POWERFUL] = 3000;
        life[POWERFUL] = 6;
        speed[POWERFUL] = 1;
        image[POWERFUL] = imageLoader.getImage("/gfx/ship/" + POWERFUL
                + ".png");
        image[POWERFUL] = Image.createImage(image[POWERFUL], 0, 0, 40, 40,
                Sprite.TRANS_MIRROR_ROT180);

        //TYPE: UNIVERSAL
        deltaFire[UNIVERSAL] = 3000;
        life[UNIVERSAL] = 3;
        speed[UNIVERSAL] = 2;
        image[UNIVERSAL] = imageLoader.getImage("/gfx/ship/" + UNIVERSAL
                + ".png");
        image[UNIVERSAL] = Image.createImage(image[UNIVERSAL], 0, 0, 40, 40,
                Sprite.TRANS_MIRROR_ROT180);

        //TYPE: STRONG
        deltaFire[STRONG] = 1500;
        life[STRONG] = 6;
        speed[STRONG] = 1;
        image[STRONG] = imageLoader.getImage("/gfx/ship/" + STRONG + ".png");
        image[STRONG] = Image.createImage(image[STRONG], 0, 0, 40, 40,
                Sprite.TRANS_MIRROR_ROT180);
    }

    public int getDeltaFire(int type) {
        return deltaFire[type];
    }

    public int getLife(int type) {
        return life[type];
    }

    public int getSpeed(int type) {
        return speed[type];
    }

    public Image getImage(int type) {
        return image[type];
    }
}
